package kafka.reactive.demo.kafkareactivedemo;

import kafka.reactive.demo.kafkareactivedemo.rebalancer.RandomProducer;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

@SpringBootApplication
public class KafkaReactiveDemoApplication {

	private static final String BOOTSTRAP_SERVERS = "localhost:9092";
	private static final String TOPIC = "demo-topic";
	public static void main(String[] args) throws Exception {
		SampleProducer producer = new SampleProducer(BOOTSTRAP_SERVERS);
		int count = 20;
		CountDownLatch latch = new CountDownLatch(count);
		producer.sendMessages(TOPIC, count, latch);
		latch.await(10, TimeUnit.SECONDS);
		producer.close();


		//rebalancer
		/*RandomProducer randomProducer=new RandomProducer(BOOTSTRAP_SERVERS);
		randomProducer.produce();
*/
		//rebalancer
		SpringApplication.run(KafkaReactiveDemoApplication.class, args);


	}

}
