package kafka.reactive.demo.kafkareactivedemo.rebalancer;

import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.Producer;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.common.serialization.IntegerDeserializer;
import org.apache.kafka.common.serialization.IntegerSerializer;
import org.apache.kafka.common.serialization.StringDeserializer;
import org.apache.kafka.common.serialization.StringSerializer;
import reactor.kafka.sender.SenderOptions;
import org.apache.kafka.clients.consumer.*;
import org.apache.kafka.common.*;

import java.util.Arrays;
import java.util.Calendar;
import java.util.Properties;
import java.util.Random;

public class RandomConsumer {

    String topicName = "RandomProducerTopic";
    String msg;
    KafkaConsumer<String,String> consumer=null;
    String groupName="RG";
    Properties props = new Properties();

    public RandomConsumer(String bootstrapServers) {
        props.put(ConsumerConfig.BOOTSTRAP_SERVERS_CONFIG, bootstrapServers);
        props.put(ConsumerConfig.CLIENT_ID_CONFIG, "random-producer");
        props.put(ConsumerConfig.GROUP_ID_CONFIG, "groupName");
        props.put(ConsumerConfig.KEY_DESERIALIZER_CLASS_CONFIG, IntegerDeserializer.class);
        props.put(ConsumerConfig.VALUE_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class);
       // props.put(ConsumerConfig.AUTO_OFFSET_RESET_CONFIG, "earliest");
        props.put(ConsumerConfig.ENABLE_AUTO_COMMIT_CONFIG, "false");
        SenderOptions<Integer, String> senderOptions = SenderOptions.create(props);
    }


    public void  consume() {
        consumer = new KafkaConsumer<String, String>(props);
        RebalanceListner rebalanceListner = new RebalanceListner(consumer);
        consumer.subscribe(Arrays.asList(topicName),rebalanceListner);
        try{
            while (true){
                ConsumerRecords<String, String> records = consumer.poll(100);
                for (ConsumerRecord<String, String> record : records){
                    //System.out.println("Topic:"+ record.topic() +" Partition:" + record.partition() + " Offset:" + record.offset() + " Value:"+ record.value());
                    // Do some processing and save it to Database
                    rebalanceListner.addOffset(record.topic(), record.partition(),record.offset());
                }
                //consumer.commitSync(rebalanceListner.getCurrentOffsets());
            }
        }catch(Exception ex){
            System.out.println("Exception.");
            ex.printStackTrace();
        }
        finally{
            consumer.close();
        }




    }//end of consume
}//end of class
