package kafka.reactive.demo.kafkareactivedemo.rebalancer;

import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.Producer;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.common.serialization.IntegerSerializer;
import org.apache.kafka.common.serialization.StringSerializer;
import reactor.kafka.sender.KafkaSender;
import reactor.kafka.sender.SenderOptions;

import java.text.SimpleDateFormat;
import java.util.*;

public class RandomProducer {

    String topicName = "RandomProducerTopic";
    String msg;
    Properties props = new Properties();
    Producer<String, String> producer;

    public RandomProducer(String bootstrapServers) {
       /* props.put(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG, bootstrapServers);
        props.put(ProducerConfig.CLIENT_ID_CONFIG, "random-producer");
        props.put(ProducerConfig.ACKS_CONFIG, "all");
        props.put(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, IntegerSerializer.class);
        props.put(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG, StringSerializer.class);*/

        props.put("bootstrap.servers", "localhost:9092,localhost:9093");
        props.put("key.serializer","org.apache.kafka.common.serialization.StringSerializer");
        props.put("value.serializer", "org.apache.kafka.common.serialization.StringSerializer");
    }


   public void  produce() {

       // System.out.println(props);
       producer = new KafkaProducer<>(props);
       Random rg = new Random();
       Calendar dt = Calendar.getInstance();
       dt.set(2016,1,1);

       try{
        while(true){
           for(int i=0;i<100;i++){
                msg=dt.get(Calendar.YEAR)+"-"+dt.get(Calendar.MONTH)+"-"+dt.get(Calendar.DATE)+","+rg.nextInt(1000);
                producer.send(new ProducerRecord<String,String>(topicName,0,"Key",msg)).get();  //created 2 partitions
                msg=dt.get(Calendar.YEAR)+"-"+dt.get(Calendar.MONTH)+"-"+dt.get(Calendar.DATE)+","+rg.nextInt(1000);
                producer.send(new ProducerRecord<String,String>(topicName,1,"Key",msg)).get();  //created 2 partitions
            }

            dt.add(Calendar.DATE,1);
            System.out.println("Date sent for " + dt.get(Calendar.YEAR) +"-" + dt.get(Calendar.MONTH) +"-" +dt.get(Calendar.DATE));
        }
       }catch (Exception e){
           System.out.println("testex");
           System.out.println("Interrupted");
       }finally{
           producer.close();
       }

    }


}//end class


